package fr.irisa.cairn.jnimap.isl;

import java.util.HashMap;
import java.util.Map;

/*** PROTECTED REGION ID(ISLASTOpType_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */

public class ISLASTOpType  {

	int value;
	String name;

	/*** PROTECTED REGION ID(ISLASTOpType_values) DISABLED START ***/
	public static final int ISL_AST_OP_AND = 0;
	public static final int ISL_AST_OP_AND_THEN = 1;
	public static final int ISL_AST_OP_OR = 2;
	public static final int ISL_AST_OP_OR_ELSE = 3;
	public static final int ISL_AST_OP_MAX = 4;
	public static final int ISL_AST_OP_MIN = 5;
	public static final int ISL_AST_OP_MINUS = 6;
	public static final int ISL_AST_OP_ADD = 7;
	public static final int ISL_AST_OP_SUB = 8;
	public static final int ISL_AST_OP_MUL = 9;
	public static final int ISL_AST_OP_DIV = 10;
	public static final int ISL_AST_OP_FDIV_Q = 11;
	public static final int ISL_AST_OP_PDIV_Q = 12;
	public static final int ISL_AST_OP_PDIV_R = 13;
	public static final int ISL_AST_OP_ZDIV_R = 14;
	public static final int ISL_AST_OP_COND = 15;
	public static final int ISL_AST_OP_SELECT = 16;
	public static final int ISL_AST_OP_EQ = 17;
	public static final int ISL_AST_OP_LE = 18;
	public static final int ISL_AST_OP_LT = 19;
	public static final int ISL_AST_OP_GE = 20;
	public static final int ISL_AST_OP_GT = 21;
	public static final int ISL_AST_OP_CALL = 22;
	public static final int ISL_AST_OP_ACCESS = 23;
	public static final int ISL_AST_OP_MEMBER = 24;
	public static final int ISL_AST_OP_ADDRESS_OF = 25;
	/*** PROTECTED REGION END ***/
	
	public static ISLASTOpType isl_ast_op_and = new ISLASTOpType("isl_ast_op_and", ISL_AST_OP_AND);
	public static ISLASTOpType isl_ast_op_and_then = new ISLASTOpType("isl_ast_op_and_then", ISL_AST_OP_AND_THEN);
	public static ISLASTOpType isl_ast_op_or = new ISLASTOpType("isl_ast_op_or", ISL_AST_OP_OR);
	public static ISLASTOpType isl_ast_op_or_else = new ISLASTOpType("isl_ast_op_or_else", ISL_AST_OP_OR_ELSE);
	public static ISLASTOpType isl_ast_op_max = new ISLASTOpType("isl_ast_op_max", ISL_AST_OP_MAX);
	public static ISLASTOpType isl_ast_op_min = new ISLASTOpType("isl_ast_op_min", ISL_AST_OP_MIN);
	public static ISLASTOpType isl_ast_op_minus = new ISLASTOpType("isl_ast_op_minus", ISL_AST_OP_MINUS);
	public static ISLASTOpType isl_ast_op_add = new ISLASTOpType("isl_ast_op_add", ISL_AST_OP_ADD);
	public static ISLASTOpType isl_ast_op_sub = new ISLASTOpType("isl_ast_op_sub", ISL_AST_OP_SUB);
	public static ISLASTOpType isl_ast_op_mul = new ISLASTOpType("isl_ast_op_mul", ISL_AST_OP_MUL);
	public static ISLASTOpType isl_ast_op_div = new ISLASTOpType("isl_ast_op_div", ISL_AST_OP_DIV);
	public static ISLASTOpType isl_ast_op_fdiv_q = new ISLASTOpType("isl_ast_op_fdiv_q", ISL_AST_OP_FDIV_Q);
	public static ISLASTOpType isl_ast_op_pdiv_q = new ISLASTOpType("isl_ast_op_pdiv_q", ISL_AST_OP_PDIV_Q);
	public static ISLASTOpType isl_ast_op_pdiv_r = new ISLASTOpType("isl_ast_op_pdiv_r", ISL_AST_OP_PDIV_R);
	public static ISLASTOpType isl_ast_op_zdiv_r = new ISLASTOpType("isl_ast_op_zdiv_r", ISL_AST_OP_ZDIV_R);
	public static ISLASTOpType isl_ast_op_cond = new ISLASTOpType("isl_ast_op_cond", ISL_AST_OP_COND);
	public static ISLASTOpType isl_ast_op_select = new ISLASTOpType("isl_ast_op_select", ISL_AST_OP_SELECT);
	public static ISLASTOpType isl_ast_op_eq = new ISLASTOpType("isl_ast_op_eq", ISL_AST_OP_EQ);
	public static ISLASTOpType isl_ast_op_le = new ISLASTOpType("isl_ast_op_le", ISL_AST_OP_LE);
	public static ISLASTOpType isl_ast_op_lt = new ISLASTOpType("isl_ast_op_lt", ISL_AST_OP_LT);
	public static ISLASTOpType isl_ast_op_ge = new ISLASTOpType("isl_ast_op_ge", ISL_AST_OP_GE);
	public static ISLASTOpType isl_ast_op_gt = new ISLASTOpType("isl_ast_op_gt", ISL_AST_OP_GT);
	public static ISLASTOpType isl_ast_op_call = new ISLASTOpType("isl_ast_op_call", ISL_AST_OP_CALL);
	public static ISLASTOpType isl_ast_op_access = new ISLASTOpType("isl_ast_op_access", ISL_AST_OP_ACCESS);
	public static ISLASTOpType isl_ast_op_member = new ISLASTOpType("isl_ast_op_member", ISL_AST_OP_MEMBER);
	public static ISLASTOpType isl_ast_op_address_of = new ISLASTOpType("isl_ast_op_address_of", ISL_AST_OP_ADDRESS_OF);
	
	public static ISLASTOpType build(long value) {
		return getFromInt((int) value) ;
	}
	
	
	public static  ISLASTOpType getFromInt(int value) {
		/*** PROTECTED REGION ID(ISLASTOpType_getValues) ENABLED START ***/
		switch (value) {
			case ISL_AST_OP_AND :
				return isl_ast_op_and;
			case ISL_AST_OP_AND_THEN :
				return isl_ast_op_and_then;
			case ISL_AST_OP_OR :
				return isl_ast_op_or;
			case ISL_AST_OP_OR_ELSE :
				return isl_ast_op_or_else;
			case ISL_AST_OP_MAX :
				return isl_ast_op_max;
			case ISL_AST_OP_MIN :
				return isl_ast_op_min;
			case ISL_AST_OP_MINUS :
				return isl_ast_op_minus;
			case ISL_AST_OP_ADD :
				return isl_ast_op_add;
			case ISL_AST_OP_SUB :
				return isl_ast_op_sub;
			case ISL_AST_OP_MUL :
				return isl_ast_op_mul;
			case ISL_AST_OP_DIV :
				return isl_ast_op_div;
			case ISL_AST_OP_FDIV_Q :
				return isl_ast_op_fdiv_q;
			case ISL_AST_OP_ZDIV_R :
				return isl_ast_op_zdiv_r;
			case ISL_AST_OP_PDIV_Q :
				return isl_ast_op_pdiv_q;
			case ISL_AST_OP_PDIV_R :
				return isl_ast_op_pdiv_r;
			case ISL_AST_OP_COND :
				return isl_ast_op_cond;
			case ISL_AST_OP_SELECT :
				return isl_ast_op_select;
			case ISL_AST_OP_EQ :
				return isl_ast_op_eq;
			case ISL_AST_OP_LE :
				return isl_ast_op_le;
			case ISL_AST_OP_LT :
				return isl_ast_op_lt;
			case ISL_AST_OP_GE :
				return isl_ast_op_ge;
			case ISL_AST_OP_GT :
				return isl_ast_op_gt;
			case ISL_AST_OP_CALL :
				return isl_ast_op_call;
			case ISL_AST_OP_ACCESS:
				return isl_ast_op_access;
			case ISL_AST_OP_MEMBER:
				return isl_ast_op_member;
			case ISL_AST_OP_ADDRESS_OF:
				return isl_ast_op_address_of;
			default :
				return null;
		}
		/*** PROTECTED REGION END ***/
	}

	private ISLASTOpType(String name, int value) {
		this.value=value;
		this.name=name;
	}
	
	public int getValue() {
		return this.value;
	}

	public String getName() {
		return this.name;
	}
	
}
